/* Generated By:JavaCC: Do not edit this line. Token.java Version 3.0 */
/*
 *  (c) Copyright 2001,2004  Hewlett-Packard Development Company, LP
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 * * $Id: Token.java,v 1.4 2004/03/16 22:23:07 jeremy_carroll Exp $
   
   AUTHOR:  Jeremy J. Carroll
*/
package com.hp.hpl.jena.rdf.arp;

/**
 * Describes the input token stream.
 */

class Token implements RDFParserConstants, Cloneable {
	static private boolean COUNT = false;
	static private int dead = 0;
	static private int alive = 0;
	private boolean isDead = false;
	protected void finalize() {
		if (COUNT && !isDead) {
			isDead = true;
			dead++;
		}
	}
	final Location location;
	Token(int kind, Location where) {
		if (COUNT) initCounting();
		this.kind = kind;
		this.location = where;
	}
	Token() {
		if (COUNT) initCounting();
		location = null;
	}
	private void initCounting() {
		alive++;
		if (alive % 500 == 0) {
			Runtime.getRuntime().gc();
			Runtime.getRuntime().gc();
			System.err.println(dead + "/" + alive);
		}
	}

	/**
	 * An integer that describes the kind of this token.  This numbering
	 * system is determined by JavaCCParser, and a table of these numbers is
	 * stored in the file ...Constants.java.
	 */
	public int kind;

	/**
	  * A reference to the next regular (non-special) token from the input
	  * stream.  If this is the last token from the input stream, or if the
	  * token manager has not read tokens beyond this one, this field is
	  * set to null.  
	  */
	public Token next;

	public Object clone() {
		try {
			alive++;
			return super.clone();
		} catch (CloneNotSupportedException e) {
			return "Impossible";
		}
	}

	/**
	 * Returns the image.
	 */
	public String toString() {
		return tokenImage[kind];
	}

	/**
	 * Returns a new Token object, by default. However, if you want, you
	 * can create and return subclass objects based on the value of ofKind.
	 * Simply add the cases to the switch for all those special cases.
	 * For example, if you have a subclass of Token called IDToken that
	 * you want to create if ofKind is ID, simlpy add something like :
	 *
	 *    case MyParserConstants.ID : return new IDToken();
	 *
	 * to the following switch statement. Then you can cast matchedToken
	 * variable to the appropriate type and use it in your lexical actions.
	public static final Token newToken(int ofKind)
	{
	   switch(ofKind)
	   {
	     default : return new Token();
	   }
	}
	 */

}
